#include <iostream.h>
#include <conio.h>

class node
{
	private:	float data; node* link;

	public:
   	friend class linklist;
};

class linklist
{
	private: node* root;

	public:
		linklist(){root=NULL;}

      void add(float);
   	float getdata(int)const;
      const node* getlink(int)const;
   	void setdata(int,float)const;
   	void insert(int,float)const;
   	void remove(float)const;
   	float remove_at(int)const;
   	void traverse()const;

      bool ismember(float)const;  //ismember checks whether the given data already exists in the linklist obj or not
};

		void linklist::add(float dat)
   	{
   		node* curr=root;
      	node* temp= new node;

      	temp->data=dat;
      	temp->link=NULL;

      	if(curr==NULL)
      		root=temp;
      	else
      	{
      		while(curr->link!=NULL)
      			curr=curr->link;
         	curr->link=temp;
      	}
   	}

   	float linklist::getdata(int index)const
   	{
    		node* curr=root;
      	for(int i=1;(curr!=NULL&&i<index);i++)
      		curr=curr->link;
      	return curr->data;
   	}

      const node* linklist::getlink(int index)const
      {
    		node* curr=root;
      	for(int i=1;(curr!=NULL&&i<index);i++)
      		curr=curr->link;
      	return curr->link;
   	}

   	void linklist::setdata(int index,float dat)const
   	{
    		node* curr=root;
      	for(int i=1;(curr!=NULL&&i<index);i++)
      		curr=curr->link;
      	curr->data=dat;
   	}

   	void linklist::insert(int index,float dat)const
   	{
    		node* curr=root;
      	node* neo=new node;
      	node* t;

      	for(int i=1;(curr!=NULL&&i<(index-1));i++)
         	curr=curr->link;

         t=curr->link;
         curr->link=neo;
         neo->data=dat;
         neo->link=t;
   	}

   	void linklist::remove(float dat)const
   	{
    		node* curr=root;
      	node* prev=root;

      	while(curr!=NULL)
      	{
         	if(curr->data==dat)
      		{
            	prev->link=curr->link;
      			delete curr;
               curr=prev->link;
            }
            else
            {
            	prev=curr;
            	curr=curr->link;
            }
      	}
   	}

   	float linklist::remove_at(int index)const
   	{
      	node* curr=root;
      	node* prev=NULL;
      	float t;

      	for(int i=1;(curr!=NULL&&i<index);i++)
      	{
      		prev=curr;
      		curr=curr->link;
      	}
      	prev->link=curr->link;
      	t=curr->data;
      	delete curr;
      	return t;
   	}

   	void linklist::traverse()const
   	{
   		node* curr=root;
      	while(curr!=NULL)
      	{
      		cout<<"item "<<curr->data<<'\n';
            curr=curr->link;
      	}
   	}

      bool linklist::ismember(float dat)const
      {
      	node* curr=root;
         while(curr!=NULL)
         {
         	if(curr->data==dat)
            	return true;
         	curr=curr->link;
         }
         return false;
      }

main()
{
	linklist lst;

   lst.add(5); lst.add(4); lst.add(10); lst.add(9);

   cout<<"link list is\n";
   lst.traverse();
   lst.setdata(2,10);
   cout<<"\n\nlink list after setting 10 at index 2 is\n";
   lst.traverse();
   lst.insert(3,14);
   cout<<"\n\nlink list after inserting 14 at index 3 is\n";
   lst.traverse();
   lst.remove(10);
   cout<<"\n\nlink list after removing 10 is\n";
   lst.traverse();
   cout<<"\n\nlink list after removing at index 3 where item was "<<lst.remove_at(3)<<" is\n";
   lst.traverse(); cout<<endl;

   if(lst.ismember(10))	cout<<"true";	else	cout<<"false"; cout<<endl;
   if(lst.ismember(14))	cout<<"true";	else	cout<<"false";

   getch();
}