#include <iostream.h>
#include <conio.h>
#include <string.h>

class std
{
  const int roll;
  float gpa;
  char* name;

  public:
  	std():roll(0){}
  	std(int r,char* val):roll(r),gpa(0.0)	//parametrized constructor with member initialization list
   {
   	if(val!=NULL)
      {
      	name=new char[strlen(val)+1];
         strcpy(name,val);
      }
   }

   int getroll() const {return roll;}   //in const fn the state of obj cannot be changed
                                        //only const fn can be accessible for const obj
   float getgpa() {return gpa;}

   const char* getname()const{return name;}  //getname() is returning a pointer and it should be const
                                        //because we should not give a handle to outsider
   void setname(char *value)
   {
   	if(name!=NULL)
      {
      	delete name;            
         name=NULL;
      }

      if(value!=NULL)
      {
      	name=new char[strlen(value)+1];
         strcpy(name,value);
      }
   }

   void setgpa(float g){gpa=g;}

   //void setroll(int r){roll=r;}        error as roll is const and cannot be changed


};


main()
{
	std s1(5,"saqib");
   const std s2(52,"tariq");

   cout<<"s1 roll="<<s1.getroll()<<"\ts1 name is "<<s1.getname()<<"\ts1 gpa="<<s1.getgpa()<<endl;
   cout<<"s2 roll="<<s2.getroll()<<"\ts2 name is "<<s2.getname();//<<"\ts2 gpa="<<s2.getgpa();
   														//Error: as getgpa() is not declared as const although its not changing the state of obj

   s1.setname("waqas");		s1.setgpa(3.98);
// s2.setgpa(3.4);  s2.setname("hamza");     //Error: state of const obj cannot be changed

	cout<<"\n\nafter setting values\n";
   cout<<"s1 roll="<<s1.getroll()<<"\ts1 name is "<<s1.getname()<<"\ts1 gpa="<<s1.getgpa()<<endl;
   cout<<"s2 roll="<<s2.getroll()<<"\ts2 name is "<<s2.getname();//<<"\ts2 gpa="<<s2.getgpa();   //Error

   getch();
}