#include <iostream.h>
#include <conio.h>
#include <string.h>

class Employee
{
	private:	char* name;	float taxrate;

   public:
   	Employee(){name=NULL;}
      Employee(char* n,float tr)
      {
         if(n!=NULL)
         {
         	name=new char[strlen(n)+1];
         	strcpy(name,n);
         }
      	taxrate=tr;
      }

      float gettaxrate()const{return taxrate;}
      const char* getname()const{return name;}

      void setname(char *value)
      {
      	if(name!=NULL)
         {
         	delete name;
         	name=NULL;
         }

         if(value!=NULL)
         {
         	name=new char[strlen(value)+1];
         	strcpy(name,value);
         }
      }

      virtual float calcsal()const=0;   //pure virtual fn
};

class Salariedemp: public Employee
{
	private: float salary;

   public:
   	Salariedemp(){salary=0;}
      Salariedemp(char* n,float tr,float s):Employee(n,tr){salary=s;}

      virtual float calcsal()const{return (salary-salary*gettaxrate());}
};

class Hourlyemp: public Employee
{
	private: int hrs;	float hrate;

   public:
   	Hourlyemp(){hrs=0; hrate=0;}
      Hourlyemp(char* n,float tr,int h,float hr):Employee(n,tr){hrs=h; hrate=hr;}

      virtual float calcsal()const{return (hrs*hrate-hrs*hrate*gettaxrate());}

};

class Commemp:public Employee
{
	private:	float sales;	float commrate;

   public:
   	Commemp(){sales=0; commrate=0;}
      Commemp(char* n,float tr,float s,float c):Employee(n,tr){sales=s;commrate=c;}

      virtual float calcsal()const{return (sales*commrate-sales*commrate*gettaxrate());}
};

void generate_pyroll(Employee* emp[],int size)
{
	cout<<"name\tnetsalary\n\n";

   for(int i=0;i<size;i++)
   	cout<<emp[i]->getname()<<'\t'<<emp[i]->calcsal()<<endl;
}

main()
{
	Employee*	emp[5];
   Salariedemp	s1("waqas",0.04,55000);
   Hourlyemp	h1("ahsan",0.05,150,400),h2("tariq",0.075,120,500);
   Commemp		c1("hamza",0.05,600000,0.1),c2("talha",0.1,550000,0.12);    //commision employee

   emp[0]=&s1;	emp[1]=&h1;	emp[2]=&h2;	emp[3]=&c1;	emp[4]=&c2;

   generate_pyroll(emp,5);

	getch();
}



