#include <iostream.h>
#include <conio.h>

class Complex
{
	float real,img;

   public:
   	Complex(){real=0;img=0;}
      Complex(float r,float i){real=r; img=i;}
      Complex(const Complex &rhs){real=rhs.real; img=rhs.img;} //copy constructor

      Complex operator+(const Complex &right)const   // obj+obj
      {
      	Complex t;
         t.real=real+right.real;    //as in '+' we dont need to change the state of obj
         t.img=img+right.img;       //so we shall have to return a temporary obj
         return t;
      }

      Complex operator+(const float& right)const    //obj+number
      {
      	Complex t;
         t.real=real+right;
         t.img=img;
         return t;
      }

      const Complex& operator=(const Complex& right)
      {
       	real=right.real;              //return Complex should not be const
         img=right.img;                //bcz in (c1=c2)=c3  c1=c2 must return a non const value
         return* this;                 //bt v shd nt giv a handle jst 4 the above particular case!
      }

      const Complex& operator+=(const Complex& right) //obj+=obj
      {
      	real=real+right.real;
         img=img+right.img;            //state of object is being changed so fn cannot b treated as const
         return* this;
      }

      const Complex& operator+=(const float&right)  //obj+=num
      {
       	real=real+right;
         return* this;
      }

      bool operator==(const Complex& right)const
      {
      	if(real==right.real&&img==right.img)
         	return true;
         else
         	return false;
		}

      bool operator!=(const Complex& right)const
      {
       	if(real!=right.real||img!=right.img)
         	return true;
         else
         	return false;
      }

      float getreal()const{return real;}
      float getimg()const{return img;}
};


Complex operator+(const float& left, const Complex right) //number+obj
{
	Complex t=right;     //left operand is not an obj so cannot define in the class
   return t+=left;
}


main()
{
	Complex c1(5,10),c2(10,100),c3(2.5,-5);
   Complex c4=c1+c2+1+c3+2;
   c4+=c1;	c4+=10;        //using (+,+=,==,!=) with objects(user defined types) just like pre defined types(int,float,char etc)
   
   cout<<c4.getreal()<<' '<<c4.getimg()<<endl;

   c1=c2=c3;
   if(c1==c2)	cout<<"c1=c2";
   else	cout<<"c1!=c2";
   cout<<endl;
   if(c1!=c3)	cout<<"c1!=c3";
   else	cout<<"c1=c3";

   getch();
}
