#include <iostream.h>
#include <conio.h>
#include <string.h>

class Person
{
	private:	char* name;	int age;

   protected:	getage()const{return age;}

   public:
   	Person(){name=NULL;age=18;}                //default constructor should be given in parent/base class
      Person(int a){name=NULL;age=a;}
   	Person(char* n){createname(n); age=18;}       //parametrized constructors
      Person(char* n,int a){createname(n);age=a;}
      Person(const Person& p){createname(p.name); age=p.age;} //copy constructor
      ~Person(){delete name;}          //destructor

      Person& operator=(const Person& p)  //overloaded operator '=' for parent/base class
      {
      	setname(p.name);
         age=p.age;
         return* this;
      }

      const char* getname()const {return name;}

      void createname(char* val)
      {
      	if(val!=NULL)
         {
         	name=new char[strlen(val)+1];
         	strcpy(name,val);
         }
      }

      void setname(char *value)
      {
      	if(name!=NULL)
         {
         	delete name;
         	name=NULL;
         }

         if(value!=NULL)
         {
         	name=new char[strlen(value)+1];
         	strcpy(name,value);
         }
      }

      void setage(int a){age=a;}
      void print()const {cout<<"\nname is "<<getname()<<"\tage="<<getage();}
};

class Student:public Person     //class Student is inherited publically from class Person
{
	private: int roll;

   public:
   	Student(){roll=0;} 								//default constructor of base class is called when
      Student(int r){roll=r;}                   //no constructor is called in member initialization list
      Student(int r,int a):Person(a){roll=r;}
      Student(char* n,int r):Person(n){roll=r;}
      Student(char* n,int r,int a):Person(n,a){roll=r;}
      Student(const Student& s):Person(s){roll=s.roll;} //automatic type conversion from Student to Person
      ~Student(){}

      Student& operator=(const Student& rhs)     //overloaded operator '=' for derived class
      {
       //static_cast<Person &>(*this)=rhs; //implicit call of '=' op of base class
         Person::operator=(rhs);           //explicitly calling '=' op of base class
      	roll=rhs.roll;
         return* this;                     //default '=' is called by the compliler if no '=' operator is defined
      }                                    //default '=' automaticaly cals base clas '=' b4 asigning derivd members

      void print()const {Person::print(); cout<<"\troll="<<roll;}   //overrided fn print()

      void setroll(int r){roll=r;}
      int getroll()const{return roll;}
};

main()
{
	Student std1,std2(67),std3(68,19),std4("hamza",35),std5("tariq",52,20),CR=std5;

   std1.setname("waqas");	std2.setname("moin");	std3.setname("ahsan");
	std1.setroll(5);	std2.setroll(50);	std3.setroll(19);
   std2.setage(20);	std4.setage(19); //setage() is not a member fn of Student bt inherited from Person

   std1.print(); std2.print(); std3.print(); std4.print(); std5.print(); CR.print();

   Person* ptr;
   ptr=&std4;
   cout<<endl;
   ptr->print();              //ptr only points to Person class
   std3.Person::print();      //print() of Person can also be called from obj of Student

 //cout<<ptr->getage();    getage is protected
 //cout<<ptr->getroll();   getroll is only for a Student

   Person p1,p2(25),p3("aslam"),p4("ali",30),p5=p4;
   p2=p3;
   p1.setname("asad");
   cout<<endl;
   p1.print();	p2.print();	p3.print();	p4.print();	p5.print();

/* Student* ptr2;
	ptr2=&p1;              cannot convert a Person into Student
   cout<<endl;            bcz it is not necessary for a person to be a Student
   ptr2->print();
   p3.Student::print(); */

   getch();
}

